///////////////////////////////////////////////////////////
//Lösung zu Aufgabe 4 in Kapitel Turtlegrafik
////////////////////////////////////////////////////////
// Zustand der Turtle
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1100;
int h=1100;

// Ausgangsseitenlänge des Quadats
int laenge = 512;
int depth = 1;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
}

///////////////////////////////////////////////////////////

void draw() {
  background(255);
  translate(30,height-30); 
  strokeWeight(2);
  setColor(color(255,0,0));
  penDown();
  kurveL(depth,laenge,60);
  noLoop();
}

///////////////////////////////////////////////////////////

void keyPressed() {
 if (key == 's') save("tmp.png");
 if (key=='+') { if (depth<10) {depth++; laenge/=2; }}
 if (key=='-') { if (depth>1 ) {depth--; laenge*=2; }}
 redraw();
}

///////////////////////////////////////////////////////////

void kurveR(int tiefe,int laenge,float winkel) {
  
  // am Ende der Rekursion mache nichts mehr
  if (tiefe==0) { 
     move(laenge); 
     return;
  }
  turn(-winkel);
  kurveL(tiefe-1,laenge,winkel);
  turn(winkel);
  kurveR(tiefe-1,laenge,winkel);
  turn(winkel);
  kurveL(tiefe-1,laenge,winkel);
  turn(-winkel);
}

/////////////////////////////////////////////////////////

void kurveL(int tiefe,int laenge,float winkel) {
  
  // am Ende der Rekursion mache nichts mehr
  if (tiefe==0) { 
     move(laenge); 
     return;
  }
  turn(winkel);
  kurveR(tiefe-1,laenge,winkel);
  turn(-winkel);
  kurveL(tiefe-1,laenge,winkel);
  turn(-winkel);
  kurveR(tiefe-1,laenge,winkel);
  turn(winkel);
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) line(0,0,len,0);
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }